Bug 1077867 (CVE-2013-6438) - CVE-2013-6438 httpd: mod_dav denial of service via crafted DAV WRITE request
Summary: CVE-2013-6438 httpd: mod_dav denial of service via crafted DAV WRITE request
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2013-6438
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1077878 1077885 1077907 1078174 1078175 1078176 1078177 1078686 1078687 1078688 1078689 1127227
Blocks: 1077876 1078645 1093890 1105541 1112035
TreeView+ depends on / blocked
 
Reported: 2014-03-18 18:11 UTC by Vincent Danen
Modified: 2019-09-29 13:14 UTC (History)
40 users (show)

Fixed In Version: httpd 2.4.9
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-09-17 07:57:58 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0369 normal SHIPPED_LIVE Moderate: httpd security update 2014-04-04 00:59:19 UTC
Red Hat Product Errata RHSA-2014:0370 normal SHIPPED_LIVE Moderate: httpd security update 2014-04-04 00:59:28 UTC
Red Hat Product Errata RHSA-2014:0783 normal SHIPPED_LIVE Moderate: Red Hat JBoss Web Server 2.0.1 httpd security and bug fix update 2014-06-23 21:52:12 UTC
Red Hat Product Errata RHSA-2014:0784 normal SHIPPED_LIVE Moderate: Red Hat JBoss Web Server 2.0.1 httpd security and bug fix update 2014-06-23 21:52:03 UTC
Red Hat Product Errata RHSA-2014:0825 normal SHIPPED_LIVE Moderate: Red Hat JBoss Enterprise Application Platform 6.2 httpd security update 2014-07-01 19:03:52 UTC
Red Hat Product Errata RHSA-2014:0826 normal SHIPPED_LIVE Moderate: Red Hat JBoss Enterprise Application Platform 6.2 httpd security update 2014-07-01 19:03:39 UTC

Description Vincent Danen 2014-03-18 18:11:08 UTC
Common Vulnerabilities and Exposures assigned an identifier CVE-2013-6438 to
the following vulnerability:

Name: CVE-2013-6438
URL: http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2013-6438
Assigned: 20131104
Reference: http://svn.apache.org/viewvc/httpd/httpd/trunk/modules/dav/main/util.c
Reference: http://svn.apache.org/viewvc/httpd/httpd/trunk/modules/dav/main/util.c?r1=1528718&r2=1556428&diff_format=h
Reference: http://www.apache.org/dist/httpd/CHANGES_2.4.9

The dav_xml_get_cdata function in main/util.c in the mod_dav module in
the Apache HTTP Server before 2.4.8 does not properly remove
whitespace characters from CDATA sections, which allows remote
attackers to cause a denial of service (daemon crash) via a crafted
DAV WRITE request.

Comment 1 Vincent Danen 2014-03-18 18:33:07 UTC
Created httpd tracking bugs for this issue:

Affects: fedora-all [bug 1077878]

Comment 3 Vincent Danen 2014-03-18 19:43:31 UTC
Upstream has described this issue as follows, which is a bit different from MITRE's description:

XML parsing code in mod_dav incorrectly calculates the end of the string when removing leading spaces and places a NUL character outside the buffer, causing random crashes. This XML parsing code is only used with DAV provider modules that support DeltaV, of which the only publicly released provider is mod_dav_svn.

Comment 9 Huzaifa S. Sidhpurwala 2014-03-20 10:30:01 UTC
Detailed writeup from the original reporter at:

http://www.drcruft.com/2014/03/apache-moddav-vulnerability-cve-2013.html

Comment 13 errata-xmlrpc 2014-04-03 21:00:46 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2014:0369 https://rhn.redhat.com/errata/RHSA-2014-0369.html

Comment 14 errata-xmlrpc 2014-04-03 21:01:17 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2014:0370 https://rhn.redhat.com/errata/RHSA-2014-0370.html

Comment 16 Tomas Hoger 2014-04-17 20:14:12 UTC
This flaw is in the dav_xml_get_cdata() function.  In httpd itself, the function is called from handlers for CHECKOUT and MERGE methods, which are part of mod_dav.  However, those handlers can only call those methods when used with versioning DAV "provider" (the one that sets vsn hooks in dav_provider structure).

The httpd includes one DAV provider - DAV filesystem provider - implemented in module mod_dav_fs.  This provider does not implement versioning hooks and hence can not expose this issue.

The only other DAV provider shipped as part of Red Hat Enterprise Linux is mod_dav_svn that is part of subversion.  That is versioning provider and hence exposes issue in mod_dav's CHECKOUT and MERGE handlers.  It itself also calls the affected dav_xml_get_cdata() function directly.

Configurations using mod_dav_svn are known to be affected.  Configurations only using mod_dav_fs are not affected.

One way to ensure DAV functionality is not used and can not expose this issue is to avoid loading all dav modules by commenting all relevant LoadModule directives in httpd configuration.

Comment 17 Fedora Update System 2014-04-23 04:33:14 UTC
httpd-2.4.9-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 18 errata-xmlrpc 2014-06-23 17:55:32 UTC
This issue has been addressed in following products:

  JBoss Enterprise Web Server 2.0.1

Via RHSA-2014:0784 https://rhn.redhat.com/errata/RHSA-2014-0784.html

Comment 19 errata-xmlrpc 2014-06-23 17:55:59 UTC
This issue has been addressed in following products:

  JBEWS 2 for RHEL 5
  JBEWS 2 for RHEL 6

Via RHSA-2014:0783 https://rhn.redhat.com/errata/RHSA-2014-0783.html

Comment 20 errata-xmlrpc 2014-07-01 15:04:59 UTC
This issue has been addressed in following products:

  JBEAP 6.2 for RHEL 5
  JBEAP 6.2 for RHEL 6

Via RHSA-2014:0826 https://rhn.redhat.com/errata/RHSA-2014-0826.html

Comment 21 errata-xmlrpc 2014-07-01 15:05:22 UTC
This issue has been addressed in following products:

  Red Hat JBoss Enterprise Application Platform 6.2

Via RHSA-2014:0825 https://rhn.redhat.com/errata/RHSA-2014-0825.html


Note You need to log in before you can comment on or make changes to this bug.